; Programs to recover wffs from graph
; These don't yet deal well with messy situations having shared or
; circular pointers.

(defun wff (a)
"(wff a) -- returns representation of expression rooted at a with
           sharing represented by { n <expr>} and  { n }"
 (let (r)
   (*all (sV!! nil!!) (setq r (wff1 a)) (sV!! nil!!))
   r)
)

(defun wff1 (a)
"Like wff, handles sharing"
 (if (cmplx a)
     (if (V a)
         (list '{ a '})
         (if (or (> (F a) 1) (= (L a) a) (= (R a) a))
             (list '{ a (wff2 a) '})
             (wff2 a)))
     (wff3 a))
)

(defvar cplxtypes (list (ty-comb) (ty-cons) (ty-point)))

(defun cmplx (a)
 (member (G a) cplxtypes)
)

(defun wff2 (a)
"Like wff1, handles existential variables"
 (sV a T)
 (if (plusp (Q a)) (list 'exists (vbls a) (wff3 a)) (wff3 a))
)

(defvar nametypes (list (ty-var) (ty-dict) (ty-sysc) (ty-notn)))

(defun wff3 (a)
"Like wff2, handles basic forms"
 (let ((ty (G a)))
  (cond ((= ty (ty-comb)) (ass (wff1 (L a)) (wff1 (R a))))
	((= ty (ty-cons)) (cass (wff1 (L a)) (wff1 (R a))))
	((= ty (ty-point)) (wff1 (R a)))
	((= ty (ty-numb)) (X a))
	((member ty nametypes) (wffname a))))
)

(defun wffname (a)
"returns name for atomic node a"
 (let ((nmc (X a)))
   (if (and (= (G a) (ty-var)) (= nmc SYMIS))
       (intern (concatenate 'string "IS-" (prin1-to-string a)))
       (aref symvec nmc)))
)


(defun vbls (a)
"(vbls a) -- returns list of variables attached to a"
 (*when (and!! (VARP!!) (=!! CXTP (!! a)))
  (let ((r nil))
    (do-for-selected-processors (k)
      (setq r (cons (wffname k) r)))
    r
  ))
)

(defun ass (a b)
 (cond ((atom a) (list a b))
       ((member (car a) '({ CONS LIST LIST*)) (list a b))
       ((append a (list b))))
)

(defun cass (a b)
 (cond ((eq b '[]) (list 'LIST a))
       ((atom b) (list 'CONS a b))
       ((eq (car b) 'CONS) (list 'LIST* a (cadr b) (caddr b)))
       ((eq (car b) 'LIST) (list* 'LIST a (cdr b)))
       ((eq (car b) 'LIST*) (list* 'LIST* a (cdr b)))
       (T (list 'CONS a b)))
)
       
 